//
// UserItem.swift
//
// Generated by swagger-codegen
// https://github.com/swagger-api/swagger-codegen
//

import Foundation



public struct UserItem: Codable {

    public enum Gender: String, Codable { 
        case m = "m"
        case f = "f"
        case n = "n"
    }
    /** Unique identifier for the user */
    public var _id: Int64
    /** User login name */
    public var login: String
    /** User first name */
    public var firstName: String
    /** User last name */
    public var lastName: String
    /** User lock status: * &#x60;0&#x60; - locked * &#x60;1&#x60; - Web access allowed * &#x60;2&#x60; - Web and mobile access allowed */
    public var lockStatus: Int
    /** User has manageable rooms */
    public var hasManageableRooms: Bool
    /** List of user roles */
    public var userRoles: RoleList
    /** Job title */
    public var title: String?
    /** Gender */
    public var gender: Gender?
    /** Creation date */
    public var createdAt: Date?
    /** Last successful logon date */
    public var lastLoginSuccessAt: Date?
    /** Expiration date */
    public var expireAt: Date?
    /** User has generated private key. Possible if **TripleCrypt™ technology** is active for this customer */
    public var isEncryptionEnabled: Bool?
    /** User attributes */
    public var userAttributes: UserAttributes?
    /** Email (not used) */
    public var email: String?


    public enum CodingKeys: String, CodingKey { 
        case _id = "id"
        case login
        case firstName
        case lastName
        case lockStatus
        case hasManageableRooms
        case userRoles
        case title
        case gender
        case createdAt
        case lastLoginSuccessAt
        case expireAt
        case isEncryptionEnabled
        case userAttributes
        case email
    }


}

